<template>
    <div ref="dialog" class="mdc-dialog">
        <div class="mdc-dialog__container">
            <div
                class="mdc-dialog__surface"
                role="alertdialog"
            >
                <h2 v-if="header" class="mdc-dialog__title">{{ header }}</h2>
                <div :id="id" class="mdc-dialog__content">
                    <slot></slot>
                </div>
                <footer
                    v-if="$slots.actions"
                    class="mdc-dialog__actions"
                >
                    <slot name="actions"></slot>
                </footer>
            </div>
        </div>
        <div class="mdc-dialog__scrim"></div>
    </div>
</template>
<script>
import { MDCDialog } from '@material/dialog';

export default {
    props: {
        id: {
            type: [String, Number],
            required: true,
        },
        show: {
            type: Boolean,
            required: true,
        },
        header: {
            type: String,
        },
    },

    data() {
        return {
            dialog: null,
        };
    },

    mounted() {
        this.dialog = new MDCDialog(this.$refs.dialog);

        this.dialog.listen('MDCDialog:closing', () => {
            this.$emit('closing');
        });
    },

    watch: {
        show: function(newVal, oldVal) {
            if (newVal) {
                this.dialog.open();
            } else {
                this.dialog.close();
            }
        },
    },
};
</script>
